(let ()
  (def a (* 100 (iseq 0 20)))
  (def numprimes
       (mapcar
	(lambda(x) (length (which (primep x))))
	(mapcar
	 (lambda(i j) (iseq i j))
	 (+ 1 (butlast a))
	 (rest a)
	 )
	)
       )
  )
(defun plots()
  (plot numprimes)
  (plot (accumulate #'+ numprimes))
  (plot (accumulate #'+ numprimes) (/ (rest a) (ln (rest a))))
  )

(defun 
  base-10-to-base-n(x b)
  "
;; Examples:
 (base-10-to-base-n 100 10)
 (base-10-to-base-n 100 8)
 (base-10-to-base-n 64 2)
"
  (let (
	(res x)
	(n 0)
	digit
	num
	(newx "")
	)
    (while
	(>= res 1)
      (let ()
	(setq res (/ res b))
	(incf n)
	)
      )
    (setq 
     n (1- n)
     )
    (dolist
	(i (iseq n 0))
      (let* (
	     (digit (^ b i))
	     (num (floor (/ x digit)))
	     )
	;; (princ num)
	(setq newx (strcat newx (num-to-string num)))
	(setq x (- x (* num digit)))
	)
      )
    (read-from-string newx)
    )
  )

(defun print-m-primes-base-n (m n)
  "
;; Examples:
 (print-m-primes-base-n 600 8)
"
  (mapcar
   (lambda(x) (if (primep x) (print (base-10-to-base-n x n))))
   (iseq 2 m)
   )
  nil
  )

(mapcar
 (lambda(x) (if (primep x) (print x)))
 (+ 1 (accumulate #'* (iseq 2 5)))
 )


#|
(let ((n 6000))
  (defun prime-ratio(x) (/ x (ln x)))
  (plot prime-ratio 2 6000)
  (send my-plot :add-plot-item
	(list
	 'points
	 (iseq 1 n)
	 (accumulate
	  #'+
	  (let ((ps (mapcar #'primep (iseq 1 n))))
	    (mapcar
	     (lambda(x) (if x 1 0))
	     ps
	     ))
	  )
	 )
	)
  )
|#
